/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: ATUSITU_COMPRA                                                    */
/* Tabela : COMPRA                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 22/09/2006 - Raquel Cunha                                                  */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'ATUSITU_COMPRA'   and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
DROP TRIGGER ATUSITU_COMPRA
GO

CREATE TRIGGER ATUSITU_COMPRA
ON COLETAPR
FOR INSERT
AS
DECLARE @V_IDCOMANDO    VARCHAR(1);
DECLARE @V_NEW_NRCOMPRA VARCHAR(10);
BEGIN
   DECLARE C_DADOS CURSOR FOR
      SELECT
         'I' IDCOMANDO,
         NRCOMPRA
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)
   OPEN C_DADOS;
   FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                @V_NEW_NRCOMPRA;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_IDCOMANDO = 'I' BEGIN
         IF @V_NEW_NRCOMPRA IS NOT NULL BEGIN
            UPDATE COMPRA
            SET IDSITUCOMPRA = '4'
            WHERE NRCOMPRA = @V_NEW_NRCOMPRA AND
                  IDSITUCOMPRA NOT IN ('4', '6');
         END;
      END;

   FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                @V_NEW_NRCOMPRA;

   END;
   CLOSE C_DADOS;
   DEALLOCATE C_DADOS;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUSITU_COMPRA','4.11.056';
GO

